﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Bootik
{
    public partial class frmOrder : Form
    {
        public frmOrder()
        {
            InitializeComponent();
        }


        ProductHandller PH = new ProductHandller();
        CustomerHandller CH = new CustomerHandller();

        //کد مشتری
        int CustomerId = 0;

        //میزان تخقیق مشتریان
        int Takhfif = 0;

        Order O;
        OrderHandller OH = new OrderHandller();
        //کد سفارش برای حذف
        int orderId = 0;

        //تهداد محصول که برای حذف سفارش باید به تعداد محصول فعلی اضافه شود
        int count;

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            Takhfif = 0;
            CustomerId = 0;
            Close();
        }

        private void Order_Load(object sender, EventArgs e)
        {
            try
            {
                for (int i = 1390; i < 1500; i++)
                {
                    cmbToYear.Items.Add(i.ToString());
                }
                cmbToDay.SelectedIndex = 1;
                cmbToMonth.SelectedIndex = 1;
                cmbToYear.SelectedIndex = 1;

                cmbPayType.SelectedIndex = 1;

                dgCustomer.DataSource = CH.ShowAllSP();
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void dgProduct_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void dgProduct_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                CustomerId = CH.GetId(dgCustomer.Rows[e.RowIndex].Cells[2].Value.ToString());
                Takhfif =int.Parse( dgCustomer.Rows[e.RowIndex].Cells[3].Value.ToString());

            }
            catch (Exception ce)
            {
                MessageBox.Show(ce.Message);
            }
            //MessageBox.Show(CustomerId.ToString());
        }

        private void toolRegDaru_Click(object sender, EventArgs e)
        {

            try
            {
                if (PH.GetCount(txtBarcode.Text)-int.Parse(txtcount.Text) > 0)
                {
                    string forush;
                    string kharid;
                    string sood;
                    //dar in soorat karbar ghablan dar system sabt shode
                    if (Takhfif != 0)
                    {
                        float darsad = Convert.ToSingle(Convert.ToSingle(Takhfif) / Convert.ToSingle(100));
                        //MessageBox.Show(darsad);
                        float takhfifDarsad = Convert.ToSingle(int.Parse(PH.GetPriceForush(txtBarcode.Text)) * int.Parse(txtcount.Text)) * darsad;
                        forush = ((int.Parse(PH.GetPriceForush(txtBarcode.Text)) * int.Parse(txtcount.Text)) - takhfifDarsad).ToString();
                        kharid = (int.Parse(txtcount.Text) * int.Parse((PH.GetPriceKharid(txtBarcode.Text)))).ToString();
                        sood = (int.Parse(forush) - int.Parse(kharid)).ToString();

                        O = new Order(Initializer.CashierId, CustomerId, PH.GetId(txtBarcode.Text).ToString(), int.Parse(txtcount.Text), forush,
                        sood, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text), txtDesc.Text,cmbPayType.Text,false);
                        //MessageBox.Show(PH.GetPrice(txtBarcode.Text));
                        //MessageBox.Show("darsade takhfif : " + takhfifDarsad + "forush : " + O.SumForush + " , Kharid : " + kharid + " , sood : " + sood);
                    }
                    else
                    {
                        CustomerId = 0;
                        forush = ((int.Parse(PH.GetPriceForush(txtBarcode.Text)) * int.Parse(txtcount.Text))).ToString();
                        kharid = (int.Parse(txtcount.Text) * int.Parse((PH.GetPriceKharid(txtBarcode.Text)))).ToString();
                        sood = (int.Parse(forush) - int.Parse(kharid)).ToString();

                        O = new Order(Initializer.CashierId, CustomerId, PH.GetId(txtBarcode.Text).ToString(), int.Parse(txtcount.Text), forush,
                        sood, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text), txtDesc.Text, cmbPayType.Text, false);

                        //MessageBox.Show("forush : " + O.SumForush + " , Kharid : " + kharid + " , sood : " + sood);
                    }

                    O = new Order(Initializer.CashierId, CustomerId, txtBarcode.Text, int.Parse(txtcount.Text), forush, sood, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text), txtDesc.Text, cmbPayType.Text, false);
                    if (OH.Insert(O))
                    {
                        //az counte mahsool kam mishavad
                        PH.MinuseCount(txtBarcode.Text, int.Parse(txtcount.Text));
                        dataGridView1.DataSource = OH.ShowAll(CustomerId,int.Parse( cmbToYear.Text),int.Parse( cmbToMonth.Text),int.Parse( cmbToDay.Text));
                    }
                }
                else
                {
                    MessageBox.Show("از این محصول به در فروشگاه  به تعداد خواسته شده وجود ندارد");
                }
                lblCount.Text = PH.GetCount(txtBarcode.Text).ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void txtBarcode_TextChanged(object sender, EventArgs e)
        {
            try
            {
                lblCount.Text = PH.GetCount(txtBarcode.Text).ToString();
            }
            catch (Exception ex)
            {

            }
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            try
            {
                if (MessageBox.Show("آیا مطمئن هستید ؟ ", "پیام", MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign) == DialogResult.Yes)
                {
                    PH.AddCount(OH.GetBarCode(orderId), count);
                    if (OH.Delete(orderId))
                    {
                        dataGridView1.DataSource = OH.ShowAll(CustomerId,int.Parse( cmbToYear.Text), int.Parse(cmbToMonth.Text),int.Parse( cmbToDay.Text));
                    }
                    else
                        MessageBox.Show("عدم حذف داده مورد نظر.علت را بررسی کنید");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                orderId = int.Parse(dataGridView1.Rows[e.RowIndex].Cells[0].Value.ToString());
                txtcount.Text = (dataGridView1.Rows[e.RowIndex].Cells[2].Value.ToString());
                count = int.Parse((dataGridView1.Rows[e.RowIndex].Cells[2].Value.ToString()));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            try
            {
                string forush;
                string kharid;
                string sood;
                //dar in soorat karbar ghablan dar system sabt shode
                if (Takhfif != 0)
                {
                    float darsad = Convert.ToSingle(Convert.ToSingle(Takhfif) / Convert.ToSingle(100));
                    float takhfifDarsad = Convert.ToSingle(int.Parse(PH.GetPriceForush(txtBarcode.Text)) * int.Parse(txtcount.Text)) * darsad;
                    forush = ((int.Parse(PH.GetPriceForush(txtBarcode.Text)) * int.Parse(txtcount.Text)) - takhfifDarsad).ToString();
                    kharid = (int.Parse(txtcount.Text) * int.Parse((PH.GetPriceKharid(txtBarcode.Text)))).ToString();
                    sood = (int.Parse(forush) - int.Parse(kharid)).ToString();
                    O = new Order(Initializer.CashierId, CustomerId, PH.GetId(txtBarcode.Text).ToString(), int.Parse(txtcount.Text), forush,
                    sood, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text), txtDesc.Text, cmbPayType.Text, false);
                }
                else
                {
                    CustomerId = 0;
                    forush = ((int.Parse(PH.GetPriceForush(txtBarcode.Text)) * int.Parse(txtcount.Text))).ToString();
                    kharid = (int.Parse(txtcount.Text) * int.Parse((PH.GetPriceKharid(txtBarcode.Text)))).ToString();
                    sood = (int.Parse(forush) - int.Parse(kharid)).ToString();
                    O = new Order(Initializer.CashierId, CustomerId, PH.GetId(txtBarcode.Text).ToString(), int.Parse(txtcount.Text), forush,
                    sood, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text), txtDesc.Text, cmbPayType.Text, false);
                }

                //tedad masooli ke ghablan sefaresh dade shode
                int beforeCount = count;
                //tedad mahsooli ke ma ghasde taghire counte an ra darim
                int updateCount = int.Parse(txtcount.Text);

                //dar soorati ke meghdare ghabli az meghdari ke alan vared mikonim bashad bayad be tedade mahsool ezafe shavad
                if (beforeCount > updateCount)
                {
                    O = new Order(Initializer.CashierId, CustomerId, txtBarcode.Text, int.Parse(txtcount.Text), forush, sood, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text), txtDesc.Text, cmbPayType.Text, false);
                    PH.AddCount(OH.GetBarCode(orderId), beforeCount - updateCount);
                    if (OH.Update(O, orderId))
                    {
                        dataGridView1.DataSource = OH.ShowAll(CustomerId,int.Parse( cmbToYear.Text),int.Parse( cmbToMonth.Text), int.Parse(cmbToDay.Text));
                    }
                }
                //va dae ghere in soorat bayad kam shavad
                else if (beforeCount < updateCount)
                {
                    O = new Order(Initializer.CashierId, CustomerId, txtBarcode.Text, int.Parse(txtcount.Text), forush, sood, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text), txtDesc.Text, cmbPayType.Text, false);
                    PH.MinuseCount(OH.GetBarCode(orderId), Math.Abs(updateCount - beforeCount));
                    if (OH.Update(O, orderId))
                    {
                        dataGridView1.DataSource = OH.ShowAll(CustomerId,int.Parse( cmbToYear.Text),int.Parse( cmbToMonth.Text), int.Parse(cmbToDay.Text));
                    }
                }
                lblCount.Text = PH.GetCount(txtBarcode.Text).ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void txtcount_TextChanged(object sender, EventArgs e)
        {
            try
            {
                if (int.Parse(txtcount.Text) <= 0)
                    MessageBox.Show("تعداد را بیشتر از 0 وارد کنید");
            }
            catch (Exception ex)
            {

            }
        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            //if (CustomerId > 0)
            //{
                frmPrint p = new frmPrint(CustomerId,int.Parse(cmbToYear.Text),int.Parse(cmbToMonth.Text),int.Parse(cmbToDay.Text));
                p.ShowDialog();
            //}
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < dataGridView1.Rows.Count-1; i++)
                {
                    OH.Update(int.Parse(dataGridView1.Rows[i].Cells[0].Value.ToString()));
                }
                MessageBox.Show("خرید با موفقیت کامل انجام شد ");
                dataGridView1.DataSource = OH.ShowAll(CustomerId, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text));

                //if (MessageBox.Show("خرید با موفقیت کامل انجام شد " + "\n\n" + "آیا میخواهید رسید را ببینید ؟", "خرید موفق", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                //{
                //    frmPrint p = new frmPrint(CustomerId, int.Parse(cmbToYear.Text), int.Parse(cmbToMonth.Text), int.Parse(cmbToDay.Text));
                //    p.ShowDialog();

                //}
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {

        }
    }
}
