﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Bootik.FrmMan
{
    public partial class Cat_Manage : Form
    {
        public Cat_Manage()
        {
            InitializeComponent();
        }

        Category C;
        Category CUpdate;
        CategoryHandller CH = new CategoryHandller();
        int catCode = 0;


        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            txtname.Text = "";
            txtDesc.Text = "";
        }

        private void toolRegDaru_Click(object sender, EventArgs e)
        {
            try
            {
                C = new Category(txtname.Text,txtDesc.Text);
                if (txtname.Text != "")
                {
                    if (!CH.Exist(txtname.Text))
                    {
                        if (CH.Insert(C))
                        {
                            MessageBox.Show("داده ها با موفقیت ثبت شدند", "موفقیت", MessageBoxButtons.OK, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                            dataGridView1.DataSource = CH.ShowAll();
                        }
                        else
                            MessageBox.Show("عدم موفقیت در ثبت داده ها !!!! لطفا علت را بررسی کنید", "اخطار", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                    }
                    else
                        MessageBox.Show("این نام قبلا در بانک ذخیره شده است");
                }
                else
                {
                    MessageBox.Show("فیلد ها را کامل وارد کنید", "اخطار", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                catCode =int.Parse( dataGridView1.Rows[e.RowIndex].Cells[0].Value.ToString());
                txtname.Text = dataGridView1.Rows[e.RowIndex].Cells[1].Value.ToString();
                txtDesc.Text = dataGridView1.Rows[e.RowIndex].Cells[2].Value.ToString();
            }
            catch (Exception ec)
            {
                MessageBox.Show(ec.Message);
            }
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            try
            {
                if (MessageBox.Show("آیا مطمئن هستید ؟ ", "پیام", MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign) == DialogResult.Yes)
                {
                    if (CH.Delete(catCode.ToString()))
                        dataGridView1.DataSource = CH.ShowAll();
                    else
                        MessageBox.Show("عدم حذف داده مورد نظر.علت را بررسی کنید");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            try
            {
                CUpdate = new Category(txtname.Text, txtDesc.Text);
                if (CH.Update(CUpdate,catCode))
                {
                    dataGridView1.DataSource = CH.ShowAll();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void Cat_Manage_Load(object sender, EventArgs e)
        {
            try
            {
                    dataGridView1.DataSource = CH.ShowAll();
            }
            catch (Exception ex)
            {
                MessageBox.Show("خطای سیستم : " + ex.Message);
            }
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }
    }
}
