﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace Bootik
{
    public class ProductHandller
    {
        private DataBase DBcnn;
        private String StrSQL;

        public ProductHandller()
        {
            DBcnn = new DataBase();
            StrSQL = "";
        }


        public Boolean Insert(Product C)
        {
            Boolean b = false;
            StrSQL = "INSERT INTO Product VALUES (N'" + C.Name + "',N'" + C.KaridPrice + "',N'" + C.ForushPrice + "',N'" + C.Count + "',N'" + C.DateInsert + "',N'" + C.CatId + "',N'" + C.BarCode + "',N'" + C.Note + "');";
            try
            {
                DBcnn.ExecuteSQL(StrSQL);
                b = true;
            }
            catch (Exception e)
            {
                b = false;
            }
            return b;
        }


        public Boolean Delete(string Barcode)
        {
            Boolean b = false;
            string SS = "delete from Product where BarCode=N'" + Barcode + "';";
            try
            {
                DBcnn.ExecuteSQL(SS);
                b = true;
            }
            catch (Exception vv)
            {
                b = false;
            }
            return b;
        }

        public Boolean Update(Product P, string BarCode)
        {
            Boolean b = false;
            try
            {
                DataBase db = new DataBase();
                string SQL = "update Product set Name=N'" + P.Name + "',KaridPrice=N'" + P.KaridPrice + "',ForushPrice=N'" + P.ForushPrice + "',Count=N'" + P.Count + "',BarCode=N'" + P.BarCode + "',CatId=N'" + P.CatId + "',Note=N'" + P.Note + "' where BarCode=N'" + BarCode + "'";
                db.ExecuteSQL(SQL);
                b = true;
            }
            catch (Exception cv)
            {
                b = false;
            }
            return b;
        }


        public DataTable ShowAll()
        {
            string Sq = "select * from Product ORDER BY Name Asc";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
            }
            catch (Exception ex)
            {
                dt = null;
            }
            return dt;
        }

        



        public Boolean Exist(string Barcode)
        {
            Boolean b = false;
            string Sq = "select * from Product where BarCode='" + Barcode + "'";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
                if (dt.Rows.Count != 0)
                    b = true;
                else
                    b = false;
            }
            catch (Exception ex)
            {
                dt = null;
            }
            return b;
        }


        public int GetId(string BarCode)
        {
            int n = 0;
            string Sq = "select Id from Product where BarCode=N'" + BarCode + "'";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
                if (dt.Rows.Count != 0)
                {
                    foreach (DataRow row in dt.Rows)
                        foreach (var item in row.ItemArray)
                            n = int.Parse(item.ToString());
                }
                else
                    n = 0;
            }
            catch (Exception ex)
            {
                n = 0;
            }
            return n;
        }


        public string GetPriceForush(string BarCode)
        {
            string price = "";
            string Sq = "select ForushPrice from Product where BarCode='" + BarCode + "'";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
                if (dt.Rows.Count != 0)
                {
                    foreach (DataRow row in dt.Rows)
                        foreach (var item in row.ItemArray)
                            price = (item.ToString());
                }
                else
                    price = "0";
            }
            catch (Exception ex)
            {
                dt = null;
            }
            return price;
        }





        public string GetPriceKharid(string BarCode)
        {
            string price = "";
            string Sq = "select KaridPrice from Product where BarCode='" + BarCode + "'";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
                if (dt.Rows.Count != 0)
                {
                    foreach (DataRow row in dt.Rows)
                        foreach (var item in row.ItemArray)
                            price = (item.ToString());
                }
                else
                    price = "0";
            }
            catch (Exception ex)
            {
                dt = null;
            }
            return price;
        }


        /// <summary>
        /// بدست آوردن ظرفیت جاری
        /// </summary>
        /// <param name="barcode"></param>
        /// <returns></returns>
        public int GetCount(string barcode)
        {
            int n = 0;
            string Sq = "select Count from Product where BarCode=N'" + barcode + "'";
            System.Data.DataTable dt = new System.Data.DataTable();
            try
            {
                dt = DBcnn.ExecuteSelectSQL(Sq);
                if (dt.Rows.Count != 0)
                {
                    foreach (DataRow row in dt.Rows)
                        foreach (var item in row.ItemArray)
                            n = int.Parse(item.ToString());
                }
                else
                    n = 0;
            }
            catch (Exception ex)
            {
                n = 0;
            }
            return n;
        }



        /// <summary>
        /// این متد با هر بار سفارش ظرفیت را تغییر میدهد
        /// </summary>
        /// <param name="CourseGroupId"></param>
        /// <param name="oldCapacity"></param>
        /// <returns></returns>
        public Boolean MinuseCount(string Barcode,int count)
        {
            Boolean report = false;
            int j = GetCount(Barcode);
            int miuse = j-count;
            string Sq = "update Product set Count='" + miuse + "' where BarCode=N'" + Barcode + "'";
            try
            {
                DBcnn.ExecuteSQL(Sq);
                report = true;
            }
            catch (Exception ex)
            {
                report = false;
            }

            return report;
        }


        /// <summary>
        /// افزایش ظرفیت جاری
        /// </summary>
        /// <param name="Barcode"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public Boolean AddCount(string Barcode, int count)
        {
            Boolean report = false;
            int j = GetCount(Barcode);
            int add = j + count;
            string Sq = "update Product set Count='" + add + "' where BarCode=N'" + Barcode + "'";
            try
            {
                DBcnn.ExecuteSQL(Sq);
                report = true;
            }
            catch (Exception ex)
            {
                report = false;
            }

            return report;
        }
        




    }
}
