﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;



namespace Bootik
{
    public partial class LogIn : Form
    {
        public LogIn()
        {
            InitializeComponent();
        }
        LoginLogoutHandller LO = new LoginLogoutHandller();
        ManagerHandller MH = new ManagerHandller();
        CashierHandller CH = new CashierHandller();
        LoginLogout L;


        private void btnExit_Click(object sender, EventArgs e)
        {
            //this.Close();
            DialogResult dialog = MessageBox.Show("آیا مطمئن هستید؟", "خروج", MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1);
            if (dialog == DialogResult.Yes)
            {
                Application.Exit();
            }
        }

        private void خروجازسیستمToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //this.Close();
            DialogResult dialog = MessageBox.Show("آیا مطمئن هستید؟", "خروج", MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1);
            if (dialog == DialogResult.Yes)
            {
                Application.Exit();
            }
        }

        

        private void btnLogin_Click(object sender, EventArgs e)
        {
            if (txtPass.Text != "" && txtUserName.Text != "")
            {
                if (radioButton1.Checked)
                {

                    if (LO.LoginManager(txtUserName.Text, txtPass.Text))
                    {
                        Initializer.ManagerId = MH.GetId(txtUserName.Text, txtPass.Text);
                        Initializer.CashierId = 0;
                        L = new LoginLogout(Initializer.shelltime() + " , " + DateTime.Now.ToShortTimeString(), "نامعلوم", Initializer.CashierId, Initializer.ManagerId);
                        LO.RecordTraffic(L);
                        //MessageBox.Show(id.ToString());
                        FrmMan.frmMain f = new Bootik.FrmMan.frmMain();
                        this.Hide();
                        f.ShowDialog();
                    }
                    else
                        MessageBox.Show("نام کاربری یا رمز عبور در سیستم تعریف نشده است", "توجه ", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);    


                }
                else if (radioButton2.Checked)
                {
                    if (LO.LoginCashier(txtUserName.Text, txtPass.Text))
                    {
                        Initializer.CashierId = CH.GetId(txtUserName.Text, txtPass.Text);
                        Initializer.ManagerId = 0;
                        L = new LoginLogout(Initializer.shelltime() + " , " + DateTime.Now.ToShortTimeString(), "نامعلوم", Initializer.CashierId, Initializer.ManagerId);
                        LO.RecordTraffic(L);
                        //int id = CH.GetId(txtUserName.Text, txtPass.Text);
                        //MessageBox.Show(id.ToString());
                        FrmCashier.frmMainCashier f = new Bootik.FrmCashier.frmMainCashier();
                        this.Hide();
                        f.ShowDialog();
                    }
                    else
                        MessageBox.Show("نام کاربری یا رمز عبور در سیستم تعریف نشده است", "توجه ", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);    

                }
                else
                    MessageBox.Show("لطفا یکی از آیتم های مدیر یا صندوق دار را انتخاب کنید","توجه ",MessageBoxButtons.OK,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button1,MessageBoxOptions.RightAlign);
            }
            else
                MessageBox.Show("رمز عبور یا نام کاربری را وارد کنید ");
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            txtPass.Text = "";
            txtUserName.Text = "";
        }

       

        private void LogIn_Load(object sender, EventArgs e)
        {
            txtPass.Enabled = false;
            txtUserName.Enabled = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            txtPass.Enabled = true;
            txtUserName.Enabled = true;
        }

        private void دربارهیماToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("سامانه فروش فروشگا های بوتیک " + "\n\n\n" + "نسخه :             " + "1.0.1" + "\n\n", "www.SourceCodes.ir ", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
            
        }

        private void دربارهیسیستمToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("  " + "\n\n" + "تهیه و پیاده سازی برنامه : ... " + "\n\n" + "شماره دانشجویی : ..." + "\n\n" + "ایمیل : ... ", "درباره برنامه نویس ", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
            
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            txtPass.Enabled = true;
            txtUserName.Enabled = true;
        }
    }
}
